=== modified file 'src/com/goldencode/p2j/util/BlockDefinition.java'
--- old/src/com/goldencode/p2j/util/BlockDefinition.java	2022-01-20 16:18:02 +0000
+++ new/src/com/goldencode/p2j/util/BlockDefinition.java	2022-09-06 18:22:04 +0000
@@ -48,6 +48,12 @@
 ** 025 GES 20210809          Added finallyBlock runnable.
 **     CA  20220120          Improved performance for finalizables, keep them already sorted by their weight.
 **                           ConditionListener's are kept in their own list.
+**     CA  20220901          Refactored scope notification support: ScopeableFactory was removed, and the 
+**                           registration is now specific to each type of scopeable.  For each case, the block
+**                           will be registered for scope support (for that particular scopeable) only when
+**                           the scopeable is 'active' (i.e. unnamed streams or accumulators are used).  This
+**                           allows a lazy registration of scopeables, to avoid the unnecessary overhead of
+**                           processing all the scopeables for each and every block.
 */
 
 /*
@@ -106,6 +112,7 @@
 package com.goldencode.p2j.util;
 
 import java.util.*;
+import java.util.BitSet;
 import java.util.function.*;
 
 import com.goldencode.p2j.security.*;
@@ -240,6 +247,23 @@
     */
    public List<Finalizable>[] finalizables = new ArrayList[WeightFactor.WEIGHTS_ARRAY_SIZE];
    
+   /**
+    * The list of {@link Scopeable} instances which are required to be processed in this block.  
+    * <p>
+    * This list is dynamically adjusted - it can be added a new scopeable before or after the block has started.
+    * If the new instance is registered after the block has started, the {@link Scopeable#scopeStart()} will 
+    * be executed at the time of registration.
+    * <p>
+    * The map key is the scopeable's class, as only an instance of each type can be registered. 
+    */
+   public List<Scopeable> scopeList = null;
+   
+   /**
+    * A bitset to mark which {@link Scopeable} instances are registered at this block, using the 
+    * {@link ScopeId} as returned by {@link Scopeable#getScopeId()}.
+    */
+   public BitSet scopeables = null;
+   
    /** The list of condition listeners.  Processed in the registration order.. */
    public List<ConditionListener> conditionListeners = new ArrayList<>(2);
    

=== modified file 'src/com/goldencode/p2j/util/BlockManager.java'
--- old/src/com/goldencode/p2j/util/BlockManager.java	2022-08-17 07:58:35 +0000
+++ new/src/com/goldencode/p2j/util/BlockManager.java	2022-09-06 18:22:04 +0000
@@ -216,6 +216,12 @@
 **                           in old-style ABL function must remain the same. Refs: #6567.
 **     TW  20220804          Harden against NPE.
 **     TW  20220817          Error-status:error must be set for return error in static method.
+**     CA  20220901          Refactored scope notification support: ScopeableFactory was removed, and the 
+**                           registration is now specific to each type of scopeable.  For each case, the block
+**                           will be registered for scope support (for that particular scopeable) only when
+**                           the scopeable is 'active' (i.e. unnamed streams or accumulators are used).  This
+**                           allows a lazy registration of scopeables, to avoid the unnecessary overhead of
+**                           processing all the scopeables for each and every block.
 */
 
 /*
@@ -527,8 +533,6 @@
       
       // ensure certain context-local data has loaded
       ProcedureManager.load();
-      ArrayAssigner.load();
-      ObjectOps.load();
 
       topLevelBlock(null, referent, null, lvl, BlockType.EXTERNAL_PROC, block);
    }
@@ -588,8 +592,6 @@
       
       // ensure certain context-local data has loaded
       ProcedureManager.load();
-      ArrayAssigner.load();
-      ObjectOps.load();
 
       topLevelBlock(def, referent, null, lvl, BlockType.EXTERNAL_PROC, block);
    }

=== modified file 'src/com/goldencode/p2j/util/ControlFlowOps.java'
--- old/src/com/goldencode/p2j/util/ControlFlowOps.java	2022-08-17 07:58:35 +0000
+++ new/src/com/goldencode/p2j/util/ControlFlowOps.java	2022-09-06 18:22:04 +0000
@@ -245,6 +245,12 @@
 **     TW  20220806          Error-status:error must be set for return error in dynamic-invoke of method
 **                           of ABL class. Fixes xfer testc ErrorStatusFlowTester.w Test06. 
 **     TW  20220817          Error-status:error must be set for return error in static method.
+**     CA  20220901          Refactored scope notification support: ScopeableFactory was removed, and the 
+**                           registration is now specific to each type of scopeable.  For each case, the block
+**                           will be registered for scope support (for that particular scopeable) only when
+**                           the scopeable is 'active' (i.e. unnamed streams or accumulators are used).  This
+**                           allows a lazy registration of scopeables, to avoid the unnecessary overhead of
+**                           processing all the scopeables for each and every block.
 */
 
 /*
@@ -451,6 +457,14 @@
    }
 
    /**
+    * Reset the {@link WorkArea#returnValueSetInRootScope} flag.
+    */
+   public static void resetReturnValueSetInRootScope()
+   {
+      work.obtain().returnValueSetInRootScope = false;
+   }
+   
+   /**
     * Sets the most recent RETURN-VALUE for the current user's session.
     *
     * @param    returnValue
@@ -8086,7 +8100,6 @@
     * Stores global data relating to the state of the current context.
     */
    private static class WorkArea
-   implements Scopeable
    {  
       /** Helper to use the ProcedureManager without any context local lookups. */
       private final ProcedureManager.ProcedureHelper pm = ProcedureManager.getProcedureHelper();
@@ -8169,36 +8182,6 @@
          inHandleResolvers.add(internalResolver);
          inHandleResolvers.add(internalProcSuperResolver);
          inHandleResolvers.add(sessionSuperResolver);
-
-         TransactionManager.registerScopeable(this);
-      }
-
-      /**
-       * Provides a notification that a new scope is about to be entered.
-       */
-      @Override
-      public void scopeStart()
-      {
-         if (tm.isRootNestingLevel())
-         {
-            returnValueSetInRootScope = false;
-         }
-      }
-
-      /**
-       * No-op.
-       */
-      @Override
-      public void scopeFinished()
-      {
-      }
-
-      /**
-       * No-op.
-       */
-      @Override
-      public void scopeDeleted()
-      {
       }
    }
    

=== modified file 'src/com/goldencode/p2j/util/ObjectOps.java'
--- old/src/com/goldencode/p2j/util/ObjectOps.java	2022-02-09 14:18:48 +0000
+++ new/src/com/goldencode/p2j/util/ObjectOps.java	2022-09-06 18:22:04 +0000
@@ -61,6 +61,12 @@
 **     CA  20220203 A small performance improvement for scopeFinished.
 **     CA  20220208 Objects deserialized from a remote appserver call can be automatically registered as known
 **                  instances.  Fixed a 'pendingAssign' bug when the root block exits. 
+**     CA  20220901 Refactored scope notification support: ScopeableFactory was removed, and the registration 
+**                  is now specific to each type of scopeable.  For each case, the block will be registered 
+**                  for scope support (for that particular scopeable) only when the scopeable is 'active' 
+**                  (i.e. unnamed streams or accumulators are used).  This allows a lazy registration of 
+**                  scopeables, to avoid the unnecessary overhead of processing all the scopeables for each
+**                  and every block.
 */
 
 /*
@@ -963,7 +969,7 @@
       // if an error was throw from within a c'tor (or UNDO, THROW with ROUTINE-LEVEL ON ERROR UNDO, THROW.)
       // then the initialization failed and call the destructors for all initialized classes
       
-      pendingInitialize(ref);
+      pendingInitialize(wa, ref);
       
       boolean ok = false;
       boolean err = false;
@@ -1491,17 +1497,7 @@
    {
       loadClass(cls);
    }
-   
-   /**
-    * Ensure all the context-local data has initialized (to be able to listen for scope 
-    * notifications).
-    */
-   static void load()
-   {
-      // needed to ensure the variable is loaded, so it listens for scope notifications
-      local.get();
-   }
-   
+
    /**
     * Increment the reference counter for this instance.
     * 
@@ -1612,6 +1608,8 @@
       WorkArea wa = local.get();
       
       wa.pendingObjects.addAll(Arrays.asList(objects));
+      
+      wa.tm.registerPendingScopeable(wa);
    }
 
    /**
@@ -1642,6 +1640,8 @@
          return;
       
       WorkArea wa = local.get();
+      wa.tm.registerBlockScopeable(wa);
+      
       Set<_BaseObject_> pending = wa.pendingAssigned.peek();
       if (pending == Collections.EMPTY_SET)
       {
@@ -1657,16 +1657,32 @@
     * @param    ref
     *           The legacy instance.
     */
-   static void pendingInitialize(_BaseObject_ ref)
+   private static void pendingInitialize(WorkArea wa, _BaseObject_ ref)
    {
-      WorkArea wa = local.get();
-      Set<_BaseObject_> pending = wa.pendingInitialized.peek();
-      if (pending == Collections.EMPTY_SET)
-      {
-         wa.pendingInitialized.pop();
-         wa.pendingInitialized.push(pending = Collections.newSetFromMap(new IdentityHashMap<>()));
-      }
-      pending.add(ref);
+      List<Object> savePending = wa.pendingObjects.isEmpty() ? null : new ArrayList<>(wa.pendingObjects);
+      try
+      {
+         // clear and restore the pending objects, as 'registerBlockScopeable' may register current block for
+         // scope notifications, but the 'pending' objects are not ours.
+         wa.pendingObjects.clear();
+         wa.tm.registerBlockScopeable(wa);
+         
+         Set<_BaseObject_> pending = wa.pendingInitialized.peek();
+         if (pending == Collections.EMPTY_SET)
+         {
+            wa.pendingInitialized.pop();
+            wa.pendingInitialized.push(pending = Collections.newSetFromMap(new IdentityHashMap<>()));
+         }
+         pending.add(ref);
+      }
+      finally
+      {
+         wa.pendingObjects.clear();
+         if (savePending != null)
+         {
+            wa.pendingObjects.addAll(savePending);
+         }
+      }
    }
    
    /**
@@ -2591,15 +2607,7 @@
       
       /** The map of instantiated {@link LegacyClass} objects. */
       private Map<Class<? extends _BaseObject_>, LegacyClass> legacyClasses = new IdentityHashMap<>();
-      
-      /**
-       * Initialize by registering this instance for scope notifications.
-       */
-      public WorkArea()
-      {
-         TransactionManager.registerScopeable(this);
-      }
-      
+
       /**
        * Provides a notification that a new scope is about to be entered.
        * <p>
@@ -2799,6 +2807,17 @@
       }
 
       /**
+       * Get the {@link ScopeId} for the instance.
+       * 
+       * @return   {@link ScopeId#OBJECT_OPS}.
+       */
+      @Override
+      public ScopeId getScopeId()
+      {
+         return ScopeId.OBJECT_OPS;
+      }
+      
+      /**
        * Check if a destructor with the given name is defined in the specified class.
        * 
        * @param    cls

=== modified file 'src/com/goldencode/p2j/util/ProcedureManager.java'
--- old/src/com/goldencode/p2j/util/ProcedureManager.java	2022-08-17 07:58:35 +0000
+++ new/src/com/goldencode/p2j/util/ProcedureManager.java	2022-09-06 18:22:04 +0000
@@ -201,6 +201,12 @@
 **                  in old-style ABL function must remain the same. Refs: #6567.
 **     TW  20220806 Error-status:error must be set for return error in method. Javadoc fix.
 **     TW  20220817 Error-status:error must be set for return error in static method.
+**     CA  20220901 Refactored scope notification support: ScopeableFactory was removed, and the registration 
+**                  is now specific to each type of scopeable.  For each case, the block will be registered 
+**                  for scope support (for that particular scopeable) only when the scopeable is 'active' 
+**                  (i.e. unnamed streams or accumulators are used).  This allows a lazy registration of 
+**                  scopeables, to avoid the unnecessary overhead of processing all the scopeables for each
+**                  and every block.
 */
 
 /*
@@ -480,6 +486,8 @@
          return;
       }
       
+      BufferManager.registerScopeable(BufferManager.get());
+      
       Object referent = _thisProcedure(wa);
       ProcedureData pp = locateProcedure(wa, referent);
 
@@ -4922,6 +4930,8 @@
       @Override
       public void scopeStart()
       {
+         // WARNING: in TransactionManager, this is called only for top-level blocks.
+
          BlockType bt = tm.getBlockType();
          
          if (bt.equals(BlockType.EXTERNAL_PROC) ||
@@ -4992,6 +5002,8 @@
       @Override
       public void scopeFinished()
       {
+         // WARNING: in TransactionManager, this is called only for top-level blocks.
+
          BlockType bt = tm.getBlockType();
          if (bt.equals(BlockType.EXTERNAL_PROC) ||
              bt.equals(BlockType.INTERNAL_PROC) ||
@@ -5127,6 +5139,19 @@
       }
       
       /**
+       * Get the {@link ScopeId} for the instance.
+       * 
+       * @return   <code>null</code>, as the scope notification is done explicitly via 
+       *           {@link TransactionManager}.
+       */
+      @Override
+      public ScopeId getScopeId()
+      {
+         // no ID required, as this is called explicitly in TransactionManager
+         return null;
+      }
+      
+      /**
        * Get the map of session's super-procedures.
        */
       public Map<Object, ProcedureData> getSessionSuperProcedures()

=== modified file 'src/com/goldencode/p2j/util/Scopeable.java'
--- old/src/com/goldencode/p2j/util/Scopeable.java	2017-04-01 23:33:34 +0000
+++ new/src/com/goldencode/p2j/util/Scopeable.java	2022-09-06 18:22:04 +0000
@@ -3,14 +3,20 @@
 ** Abstract : the interface for objects whose changes must be externally 
 **            initialized at scope start and finalized at scope exit
 **
-** Copyright (c) 2005-2017, Golden Code Development Corporation.
+** Copyright (c) 2005-2022, Golden Code Development Corporation.
 **
 ** -#- -I- --Date-- --JPRM-- -----------------------------Description-----------------------------
 ** 001 GES 20050817   @22162 Created initial version, providing an interface for objects needing 
 **                           initialization and termination callbacks at the start and end of 
 **                           every block entered and exited.
-** 005 CA  20131013          Added scopeDeleted() API, which will be called when the instantiating 
+** 002 CA  20131013          Added scopeDeleted() API, which will be called when the instantiating 
 **                           procedure where this scopeable instance was registered gets deleted.
+** 003 CA  20220901          Refactored scope notification support: ScopeableFactory was removed, and the 
+**                           registration is now specific to each type of scopeable.  For each case, the block
+**                           will be registered for scope support (for that particular scopeable) only when
+**                           the scopeable is 'active' (i.e. unnamed streams or accumulators are used).  This
+**                           allows a lazy registration of scopeables, to avoid the unnecessary overhead of
+**                           processing all the scopeables for each and every block.
 */
 /*
 ** This program is free software: you can redistribute it and/or modify
@@ -90,4 +96,12 @@
     * Provides a notification that an external scope is about to be deleted.
     */
    public void scopeDeleted();
+   
+   /**
+    * Get the {@link ScopeId} for the instance.
+    * 
+    * @return   The scope ID, or <code>null</code> for cases when the scope notification is not done via
+    *           {@link BlockDefinition#scopeList}.
+    */
+   public ScopeId getScopeId();
 }
\ No newline at end of file

=== modified file 'src/com/goldencode/p2j/util/SharedVariableManager.java'
--- old/src/com/goldencode/p2j/util/SharedVariableManager.java	2022-02-06 12:20:41 +0000
+++ new/src/com/goldencode/p2j/util/SharedVariableManager.java	2022-09-06 18:22:04 +0000
@@ -107,6 +107,12 @@
 **                           not persistent.
 **     OM  20220115          APIs for queries accept a list of static BROWSE names for detecting errors.
 **     CA  20220206          In scopeDeleted, use the ProcedureHelper instance to avoid context-local lookup.
+**     CA  20220901          Refactored scope notification support: ScopeableFactory was removed, and the 
+**                           registration is now specific to each type of scopeable.  For each case, the block
+**                           will be registered for scope support (for that particular scopeable) only when
+**                           the scopeable is 'active' (i.e. unnamed streams or accumulators are used).  This
+**                           allows a lazy registration of scopeables, to avoid the unnecessary overhead of
+**                           processing all the scopeables for each and every block.
 */
 
 /*
@@ -213,11 +219,6 @@
  * on a static basis but instead requires an instance method implementation.
  * These instance methods then call the static counterparts which is where
  * the content-local versions of the resource pools are accessed.
- * <p>
- * The initialization processing is implemented in the {@link #initialize}
- * method and it is called during server startup based on an entry in the
- * directory until the path "/server/&lt;serverId&gt;/startup" or in
- * "/server/default/startup".
  */
 public class SharedVariableManager
 implements Scopeable
@@ -233,19 +234,6 @@
    
    /** The instance state. */
    private final WorkArea wa = new WorkArea();
-    
-   /**
-    * Initialize the shared variable framework. This registers with the
-    * {@link TransactionManager TransactionManager} a factory object which
-    * creates a {@link Scopeable} instance.
-    *
-    * @throws  IllegalStateException
-    *          If invoked more than once.
-    */
-   public static void initialize()
-   {
-      TransactionManager.registerScopeableFactory(() -> local.get());
-   }
    
    /**
     * Adds a variable to the next scope that is opened.
@@ -1866,6 +1854,17 @@
    }
 
    /**
+    * Get the {@link ScopeId} for the instance.
+    * 
+    * @return   {@link ScopeId#SHARED_VARIABLE_MANAGER}.
+    */
+   @Override
+   public ScopeId getScopeId()
+   {
+      return ScopeId.SHARED_VARIABLE_MANAGER;
+   }
+   
+   /**
     * Cleanup the {@link WorkArea#bufferCreator} for the specific buffer instance.
     * 
     * @param    buffer
@@ -1986,6 +1985,9 @@
     */
    private static void addWorker(SharedRegistry sr, ScopeLevel scope, String name, Object var)
    {
+      SharedVariableManager mgr = local.get();
+      mgr.wa.tm.registerPendingScopeable(mgr);
+      
       if (scope == ScopeLevel.NEXT)
       {
          if (sr.pending == null)

